/*
 * struct_qtlmap.h
 *
 *  Created on: 1 oct. 2010
 *      Author: ofilangi
 */

#ifndef STRUCT_QTLMAP_H_
#define STRUCT_QTLMAP_H_

#define DT float               // Element ’s type
#define CAST_DT   1            // Mettre 0 si DT == double

#define EXIT_ERROR_ALLOC_DEVICE(status,devicePtr) do if (status != CUBLAS_STATUS_SUCCESS) { fprintf (stderr,"===>LINE : %i\n",__LINE__);fprintf (stderr, "Device memory allocation error:*");fprintf (stderr,devicePtr);fprintf (stderr,"*\n");exit(1); } while (0)
#define EXIT_ERROR_USE_DEVICE(status,function,devicePtr) do if (status != CUBLAS_STATUS_SUCCESS) { fprintf (stderr,"===>LINE : %i   =>STATUS:%i\n",__LINE__,status);fprintf (stderr, "** Error **");fprintf (stderr,"*\n");fprintf (stderr,function);fprintf (stderr,"*\n");fprintf (stderr,devicePtr);fprintf (stderr,"*\n");exit(2); } while (0)

#define ADD_FORTRAN long long int

/*
 * Utilise dans la premiere version . Seul le calcul de la vraisemblance etait code avec des fonction kernel
 */
typedef struct {
    int ntnivmax               ;     // Nombre de niveaux estimables maximum
    void * devicePtrXinc       ;     // Pointeur sur la matrice de contingence sur le materiel (DIM : NKD,NTNIV)
    void * devicePtrXX         ;     // Pointeur sur un tableau temporaire X'X = XINC . XINC (DIM : NTNIV,NTNIV)
    void * devicePtrVecsol     ;     // Pointeur sur le tableau resultat de la decomposition de cholesky rapportant l'estimabilite de chaque niveau (BOOLEEN DIM : NTNIV)
    void * devicePtrRHS        ;     // Pointeur sur un tableau Temporaire (DIM : NTNIV)
    void * devicePtrXB         ;     // Pointeur sur un tableau Temporaire (DIM : NTNIV)

} QTLMapDevicePtrStructProcess ;

typedef struct {
	int np                     ;     // number of family
    int nkd                    ;     // Number of animal
    int ncar                   ;     // Number of trait
    void *devicePtrY           ;     // Pointeur sur les performances Y sur le materiel (DIM : NKD)
} QTLMapDevicePtrStructUser ;


void debug_print_adresse_structure_process(QTLMapDevicePtrStructProcess * idStruct) ;
void debug_print_adresse_structure_user(QTLMapDevicePtrStructUser * idStruct);
void debug_print_gpu_memory_XX(QTLMapDevicePtrStructProcess * idStruct,int ntniv);
void debug_print_gpu_memory_Vecsol(QTLMapDevicePtrStructProcess * idStruct,int ntniv);
void debug_print_gpu_memory_RHS(QTLMapDevicePtrStructProcess * idStruct,int ntniv);
void debug_print_gpu_memory_XB(QTLMapDevicePtrStructProcess * idStruct,int nkd,int ntniv);
void debug_print_gpu_memory_Y(QTLMapDevicePtrStructUser * idStruct);
void init_memory_debug_process(QTLMapDevicePtrStructProcess * idStruct,int nkd) ;

/*   INTERFACE WITH QTLMAP ( FORTRAN )
 * cuda_set_qtlmap_user_struct_(float *y, int *ndP, int *ntnivmaxP,ADD_FORTRAN * idUrlStructUserData)
 * cuda_init_qtlmap_process_struct_(int *nkdP, int *ntnivP,ADD_FORTRAN * idUrlStruct)
 */

extern void cuda_set_qtlmap_user_struct_(double *y, int *np, int * nbL,int * nbC, ADD_FORTRAN * idUrlStructUserData);
extern void cuda_init_qtlmap_process_struct_(int *ntnivmaxP,int *nkdP,ADD_FORTRAN * idUrlStruct);
extern void cuda_free_qtlmap_struct_process_(ADD_FORTRAN * idUrlStruct);
extern void cuda_free_qtlmap_struct_user_(ADD_FORTRAN * idUrlStruct);


/******************* VERSION 2 ***************************/




//void cudaInitDeviceDataStruct(DT * xinc_d,
//		                      DT * Y_d,
//		                      int *corrLevelColPtr,
//		                      double *seuil_choPtr,
//		                      int * ndPtr,
//		                      int * nkdPtr,
//		                      int * nsimPtr,
//		                      int * npositionPtr,
//		                      int * nLevelFixPtr,
//		                      int * nLevelVarPtr,
//		                      int * npPtr,
//		                      int * sizeFamilyNp,
//		                      QTLMapStructDeviceDataLinear data);
//
//void cudaReleaseDeviceDataStruct(QTLMapStructDeviceDataLinear data);
//void cudaInitDeviceIsigSQ(QTLMapStructDeviceDataLinear data,DT *sigsquare_host,DT *sigsquare_device);
//void cudaReleaseDeviceIsigSQ(DT *sigsquare_device);
//void cudaInitDeviceWorkStruct(QTLMapStructDeviceDataLinear data,QTLMapStructDeviceWorkLinear work) ;
//void cudaReleaseDeviceWorkStruct(QTLMapStructDeviceWorkLinear work);
//void cudaInitDeviceSolutionStruct(QTLMapStructDeviceDataLinear data,QTLMapStructDeviceSolutionLinear solution);
//void cudaReleaseDeviceSolutionStruct(QTLMapStructDeviceSolutionLinear solution) ;

#endif /* STRUCT_QTLMAP_H_ */
