# !/bin/bash -v

# Test nombre de paramètres
if [ "$#" -lt 2 ]; then
echo "Nombre de paramètres incorrects !"
echo "arg1:genealogy file arg2:genotype file [qtlmap format]\n\n"
exit 3
fi

if [ ! -e "$1" ]; then
echo "genealogy file $1 does not exit! \n"
exit 2
fi
if [ ! -e "$2" ]; then
echo "genotype file $2 does not exit ! \n"
exit 2
fi

AWK_FILE='./tmp_awk_file.awk'

echo '
BEGIN { deb=0;n=0;m=0;ok="false"; } 
$0 ~ /#TYPAGE/ {  ok="true";}
$0 !~ /#TYPAGE/{
   if ( ok  == "true" ) {
     if (deb==0) { 
          for (i=1;i<=NF;i++) { 
           if ($i ==" ") continue
           mark[deb]=$i;
           deb++;
         } 
         print (deb);
          for (i=0;i<deb;i++) { 
            print mark[i];
         } 
     } else { 
       maman="0";
       papa="0";
       sexe=1 #par defaut mal
       for (j=0;j<n;j++) { 
         if (id[j]== $1) { 
           maman=mere[j];papa=pere[j];
           break
         } 
       }
       for (j=0;j<n;j++) { 
         if (pere[j]== $1) { 
           sexe="1";
           break
         } 
         if (mere[j]== $1) { 
           sexe="2";
           break
         } 
       }
       if ( maman != "" && papa != "") {
       for (i=2;i<=(NF-2);i=i+2) {   
         #mark[(i/2)]
         print i" "$1" "papa" "maman" "sexe" "$i" "$(i+1)
       } 
      }
     }
   }  else {
      id[n]=$1 ; pere[n]=$2 ; mere[n]=$3 ; gen[n]=$4;n++;
  }
 
}
' > $AWK_FILE

FILE_TMP="./tmp_res1.tmp"
FILE2_TMP="./tmp_res2.tmp"
cat $1 >> $FILE_TMP
echo '#TYPAGE'>> $FILE_TMP
cat $2  >> $FILE_TMP
echo "generating info...."
cat $FILE_TMP | awk -f $AWK_FILE > $FILE2_TMP
rm $AWK_FILE
rm $FILE_TMP
nbmarker=`head -n1 $FILE2_TMP`
sed '1,1d' $FILE2_TMP > $FILE_TMP
rm $FILE2_TMP
echo "Nb marker:"$nbmarker

listMarker=`head -n$nbmarker $FILE_TMP`
echo "List marker:"$listMarker

sed "1,$nbmarker d" $FILE_TMP > $FILE2_TMP
rm $FILE_TMP
let x=2
for n in $listMarker; do
print "generating :marker_"$n
grep "^$x " $FILE2_TMP > 'marker_'$n
let x=$x+2
done
rm $FILE2_TMP




