# !/bin/bash -v

#Generate Graphics for 2 qtl
# $1 --> datafile (input) 
# $2 --> PNG (output)
Deuxqtlpng() { 
#echo "Content-type: image/png"
#echo ""
# $1 --> fichier data
# $2 --> fichier png a generer
# $3 --> XMAX
# $4 --> YMAX
# $5 --> VALMAX
# $6 --> XMIN
# $7 --> YMIN
# $8 --> VALMIN
# $9 --> MAXPOS
echo "2QTL $1 --> $2";
gnuplot <<EOF
set title "2QTL - LR\nThe QTL are localised at positions $3 and $4 Morgan\nValue=$5"
set xlabel "Position 1"
set ylabel "Position 2"
set xtics autofreq
set ytics autofreq
set zlabel "LR"
#set zrange [$8]
#set key top
#on met un plan a z=MIN-10, utile pour plus tard threshold
valmin=$8-20
#(pos - zmin) / (zmin - zmax)
set ticslevel (valmin - $8) / ($8 - $5)
#set xyplane at valmin
#ajoute les arrete de la box principale ou est afficher la courbe
#set border 4095
set samples 25
set isosamples 10
#set label 1 "This is the surface boundary" at 0,0,valmin-50 center
color_ar=2
set arrow 1 from $3,$4,valmin to $9,$4,valmin nohead lw color_ar
set arrow 2 from $3,$4,valmin to $3,0,valmin nohead lw color_ar
set arrow 3 from $3,$4,valmin to $3,$4,$5 nohead lw color_ar
#set arrow from 3, graph 0 to 3, graph 1 nohead

#set hidden3d
set grid

#set contour
set terminal png nocrop medium size 800,600
set output "$2"
splot '$1' using (\$1):(\$2):(\$3) with points palette notitle;
splot $3,$4,0 
EOF
}
#Generate Graphics for 1 qtl
# $1 --> datafile (input) 
# $2 --> PNG (output)
# $3 --> XMAX
# $4 --> VALMAX
# $5 --> XMIN
# $6 --> VALMIN
Unqtlpng() {
echo "1QTL $1-->$2";
gnuplot <<EOF
set title "1QTL - LR\nThe QTL are localised at position $3 Morgan\nValue=$4"
set term png;
set output "$2";
set xlabel "Position";
set ylabel "LR";
set style data linespoints

plot '$1' using (\$1):(\$2) notitle ;
EOF
}

if [ "$#" -lt 1 ]; then
	echo "Missing arguments !"
	echo "--> data file (X GlobalLRT) from qtlmap (usaually [pere])"
	exit 3
fi

if [ ! -s "$1" ]; then
	echo "The file $1 does not exit! \n"
	exit 0
fi

NBTRAITS=`cat $1 | grep "X "| wc -l`

for ((TRAIT = 1; TRAIT <= $NBTRAITS; TRAIT += 1))
do
cat $1 | awk 'BEGIN { trait='$TRAIT';current=0 } { if ( $1 == "X" ) { current++ ;stop="f"} else { if ($1 == "X1") { stop="v"} ; if ( stop == "f" && current==trait ) { print $1" "$2; }} }'| more > "trait_"$TRAIT".dat"

if [  -s "trait_"$TRAIT".dat" ]; then
    X_MAX=`cat "trait_"$TRAIT".dat"  | awk ' BEGIN { MAX=-10000; X=0 ; } { if ( MAX < $2 ) { MAX=$2 ;X=$1; } } END { print X" "MAX; }'`
	X=`echo $X_MAX | cut -d" " -f1`
	MAX=`echo $X_MAX | cut -d" " -f2`
	X_MIN=`cat "trait_"$TRAIT".dat"  | awk ' BEGIN { MIN=10000; X=0 ; } { if ( MIN > $2 ) { MIN=$2 ;X=$1; } } END { print X" "MIN; }'`
	X2=`echo $X_MIN | cut -d" " -f1`
	MIN=`echo $X_MIN | cut -d" " -f2`
	Unqtlpng "trait_$TRAIT.dat" "trait_$TRAIT.png" $X $MAX $X2 $MIN
fi

rm "trait_$TRAIT.dat"

cat $1 | awk 'BEGIN { trait='$TRAIT';current=0 } { if ( $1 == "X1" ) { current++ ;stop="f"} else { if ($1 == "X") { stop="v"} ; if ( stop == "f" && current==trait ) { print $1" "$2" "$3; }} }' > "trait_"$TRAIT"_2qtl.dat"

if [  -s "trait_"$TRAIT"_2qtl.dat" ]; then
	X_Y_MAX=`cat "trait_"$TRAIT"_2qtl.dat" | awk ' BEGIN { MAX=-10000; X=0 ;Y=0; } { if ( MAX < $3 ) { MAX=$3 ;X=$1;Y=$2; } } END { print X" "Y" "MAX; }'`
	X=`echo $X_Y_MAX | cut -d" " -f1`
	Y=`echo $X_Y_MAX | cut -d" " -f2`
	MAX=`echo $X_Y_MAX | cut -d" " -f3`
	X_Y_MIN=`cat "trait_"$TRAIT"_2qtl.dat" | awk ' BEGIN { MIN=10000; X=0 ;Y=0; } { if ( MIN > $3 ) { MIN=$3 ;X=$1;Y=$2; } } END { print X" "Y" "MIN; }'`
	X2=`echo $X_Y_MIN | cut -d" " -f1`
	Y2=`echo $X_Y_MIN | cut -d" " -f2`
	MIN=`echo $X_Y_MIN | cut -d" " -f3`
    POSMAX=`cat "trait_"$TRAIT"_2qtl.dat" | tail -n1 | cut -d" " -f2`
	Deuxqtlpng "trait_"$TRAIT"_2qtl.dat" "trait_"$TRAIT"_2qtl.png" $X $Y $MAX $X2 $Y2 $MIN $POSMAX
fi

#rm "trait_"$TRAIT"_2qtl.dat"
done



