#!/bin/bash -f
# our name 
#$ -N MPI_GENOCLUSTER_QTLMAP_SIM
# pe request
#$ -S /bin/bash
#$ -pe mpich 8
#$ -q mpich
#$ -cwd
#$ -o ./sge.out
#$ -e ./sge.err
#$ -cwd
########$ -M olivier.filangi@rennes.inra.fr
#$ -m bea
#$ -v HOME
#$ -v PATH
#$ -v LD_LIBRARY_PATH
# MPIR_HOME from submitting environment
#$ -v MPIR_HOME
#$ -v TMPDIR
# ---------------------------

#
# needs in 
#   $NSLOTS          
#       the number of tasks to be used
#   $TMPDIR/machines 
#       a valid machine file to be passed to mpirun 

###################################################################
#
#   - Choisir le bon environment PE
#   1) lancer qmon => Icon "Parallele Environment Configuration"
#   2) Regarder le nombre de process maximum a lancer (Slots)
#   3) 

prefix_ompi=/local/mpich/mpich2-1.1-gf44/bin
#prefix_ompi=/local/mpich/current/bin
BASE=/home/genouest/umr0598/olfilang/qtlmap-package-0.8.1-Source
QTLMAP=$BASE/build/mpi-gfortran/src/qtlmap
WORKDIR=$BASE/sample/porc

echo "Got $NSLOTS slots."
echo "machines:"
cat $PE_HOSTFILE | cut -f1 -d" "| uniq > $TMPDIR/my_machines
echo "" >> $TMPDIR/my_machines
cat $TMPDIR/machines
echo "list:"
cat $TMPDIR/my_machines

NB_MACHINES=`cat $TMPDIR/my_machines | wc -l`

#on met un qtlmap par machine
export OMP_NUM_THREADS=1
####   $prefix_ompi/mpdboot -n $NB_MACHINES -f $TMPDIR/my_machines -r rsh -v -s -d
$prefix_ompi/mpdboot -n $NSLOTS -f $TMPDIR/machines -r rsh -s -d 
$prefix_ompi/mpiexec -l -n $NSLOTS $QTLMAP p_analyse --nsim=42

